﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=5.9
@EndOfDesignText@
#IgnoreWarnings:12
'create the generic component builder
Sub Class_Globals
	Public ID As String
	Public Instance As String
	Private properties As Map
	Public Contents As List
	Private classes As Map
	Private styles As Map
	Private LooseAttributes As List
	Private DontBreak As List
	Private Prefix As String
	Private DoAProperClose As Boolean
	Private Required As Boolean
	Private Enabled As Boolean
	Private Inline As Boolean
	Private ReadOnly As Boolean
	Private CSSRule As Map
	Private SingleQuote As List
	Private ParentID As String
	Private Text As String
	Private TextAfter As Boolean
End Sub

Sub GetStyleAttribute(attr As String) As String
	attr = attr.ToLowerCase
	attr = RemDelim(attr,":").Trim
	Dim hasItem As Boolean = styles.ContainsKey(attr)
	If hasItem Then
		Return styles.Get(attr)
	Else
		Return ""
	End If
End Sub

'add content to the element
public Sub SetContents(value As String) As HTML5
	Contents.Initialize
	Contents.clear
	If value.Length > 0 Then
		value = FormatText(value)
		Contents.Add(value)
	End If
	Return Me
End Sub


public Sub AddElementLine(el As HTML5) As HTML5
	If el <> Null Then
		Dim scode As String = el.html
		AddContent(scode)
	End If
	Return Me
End Sub


Sub SetDataRole(sValue As String) As HTML5
	AddAttribute("data-role",sValue)
	Return Me
End Sub

Sub SetROLE(sValue As String) As HTML5
	AddAttribute("role",sValue)
	Return Me
End Sub

'add content to the element
public Sub AddContentLine(value As String) As HTML5
	If value <> "" Then
		value = value.Replace(CRLF,"")
		value = FormatText(value)
		Contents.Add(value)
	End If
	Return Me
End Sub

Sub SetTypeNumbers() As HTML5
	AddAttribute("type","1")
	Return Me
End Sub

Sub SetTypeUpperCase() As HTML5
	AddAttribute("type","A")
	Return Me
End Sub

Sub SetTypeLowerCase() As HTML5
	AddAttribute("type","a")
	Return Me
End Sub

Sub SetTypeUpperCaseRoman() As HTML5
	AddAttribute("type","I")
	Return Me
End Sub

Sub SetTypeLowerCaseRoman() As HTML5
	AddAttribute("type","i")
	Return Me
End Sub


Sub SetListStyleCircle() As HTML5
	AddStyleAttribute("list-style-type","circle")
	Return Me
End Sub

Sub SetListStyleDisk() As HTML5
	AddStyleAttribute("list-style-type","disk")
	Return Me
End Sub

Sub SetListStyleNone() As HTML5
	AddStyleAttribute("list-style-type","none")
	Return Me
End Sub

Sub SetListStyleSquare() As HTML5
	AddStyleAttribute("list-style-type","square")
	Return Me
End Sub

Sub AddHeading(sSize As Int, sContent As String) As HTML5
	Dim hdr As HTML5
	Dim hKey As String = "h" & sSize
	hdr.Initialize("",hKey)
	hdr.AddContent(sContent)
	AddContent(hdr.HTML)
	Return Me
End Sub

Sub AddParagraph(sContent As String) As HTML5
	Dim p As HTML5
	p.Initialize("","p")
	p.AddContent(sContent)
	AddContent(p.HTML)
	Return Me
End Sub


'add a class to the element
Sub AddLooseAttributeOnFalseCondition(bStatus As Boolean, value As String) As HTML5
	removeAttr(value)
	If bStatus = False Then
		AddLooseAttribute(value)
	End If
	Return Me
End Sub

'change the element type
Sub SetElementTypeOnCondition(bStatus As Boolean,sElementType As String) As HTML5
	If bStatus Then
		Instance = sElementType
	End If
	Return Me
End Sub

Sub SetZIndex(zindex As String) As HTML5
	AddStyleAttribute("z-index",zindex)
	Return Me
End Sub

Sub AddContentListReverse(lst As List) As HTML5
	Dim lTot As Int = lst.Size - 1
	Dim lCnt As Int
	For lCnt = lTot To 0 Step -1
		Dim strContent As String = lst.Get(lCnt)
		AddContent(strContent)
	Next
	Return Me
End Sub


Sub SetFOR(sFor As String) As HTML5
	AddAttribute("for",sFor)
	Return Me
End Sub


Sub SetVALUE(sValue As String) As HTML5
	AddAttribute("value",sValue)
	Return Me
End Sub


Sub SetNAME(sName As String) As HTML5
	AddAttribute("name",sName)
	Return Me
End Sub

Sub SetTYPE(sValue As String) As HTML5
	AddAttribute("type",sValue)
	Return Me
End Sub

'update the attribute content property values
Sub UpdateAttribute(name As String, propValue As String) As HTML5
	If properties.ContainsKey(name) Then
		Dim svalue As String = properties.Get(name)
		svalue = svalue & ";" & propValue
		properties.Put(name,svalue)
	Else
		properties.Put(name,propValue)
	End If
	Return Me
End Sub

'add a class to the element
Sub AddLooseAttributeOnCondition(bStatus As Boolean, value As String) As HTML5
	removeAttr(value)
	If bStatus = True Then
		AddAttribute(value,"true")
	End If
	Return Me
End Sub

'add a class to the element
Sub AddLooseAttribute(value As String) As HTML5
	removeAttr(value)
	AddAttribute(value,"true")
	Return Me
End Sub


Sub MakePx(sValue As String) As String
	If sValue.EndsWith("%") Then
		Return sValue
	Else
		If sValue.EndsWith("px") Then
			Return sValue
		Else
			sValue = sValue.Trim
			sValue = sValue.Replace("px","")
			sValue = $"${sValue}px"$
			If sValue = "px" Then sValue = ""
			Return sValue
		End If
	End If
End Sub

Sub setAttrData(attribute As String, value As String) As HTML5
	If attribute.StartsWith("data-") Then
		AddAttribute(attribute,value)
	Else
		AddAttribute("data-" & attribute,value)
	End If
	Return Me
End Sub

Sub setAttrDataOnCondition(bCondition As Boolean,attribute As String, value As String) As HTML5
	removeAttrData(attribute)
	If bCondition = False Then
		Return Me
	End If
	setAttrData(attribute,value)
	Return Me
End Sub

Sub SetSRC(sValue As String, Static As Boolean) As HTML5
	Dim tmpFile As String = MvField(sValue,1,"?")
	If Static Then
		sValue = tmpFile
	Else
		sValue = tmpFile & "?" & DateTime.now
	End If
	AddAttribute("src",sValue)
	Return Me
End Sub


Sub SetALT(sValue As String) As HTML5
	AddAttribute("alt",sValue)
	Return Me
End Sub


Sub SetWidthPX(Width As String) As HTML5
	If Width <> "" Then
		AddStyleAttribute("width", MakePx(Width))
	End If
	Return Me
End Sub

Sub SetWidth(Width As String) As HTML5
	If Width <> "" Then
		AddAttribute("width", Width)
	End If
	Return Me
End Sub

Sub SetHeight(Height As String) As HTML5
	If Height <> "" Then
		AddAttribute("height", Height)
	End If
	Return Me
End Sub

Sub SetPlaceHolder(sPlaceHolder As String) As HTML5
	AddAttribute("placeholder", sPlaceHolder)
	Return Me
End Sub


Sub SetHeightPX(Height As String) As HTML5
	If Height <> "" Then
		AddStyleAttribute("height", MakePx(Height))
	End If
	Return Me
End Sub

Sub AddStyleAttributeOnCondition(bCondition As Boolean, attr As String, value As String) As HTML5
	removeStyle(attr)
	If bCondition = True Then
		AddStyleAttribute(attr,value)
	End If
	Return Me
End Sub

Sub AddAttributeOnCondition(bCondition As Boolean, attr As String, value As String) As HTML5
	removeAttr(attr)
	If bCondition = True Then
		AddAttribute(attr,value)
	End If
	Return Me
End Sub

Sub GetAttribute(attr As String) As String
	attr = attr.tolowercase
	If properties.ContainsKey(attr) Then
		Return properties.Get(attr)
	Else
		Return ""
	End If
End Sub


Sub ClassExists(value As String) As Boolean
	value = value.trim
	If value.Length > 0 Then
		Return classes.ContainsKey(value)
	End If
	Return False
End Sub


'the html string of the component
public Sub HTML As String
	Dim sOut As String = ToString
	Return sOut
End Sub

Sub AddCursor As HTML5
	AddStyleAttribute("cursor", "pointer")
	Return Me
End Sub

Sub setHREF(value As String) As HTML5
	AddAttribute("href",value)
	Return Me
End Sub

Sub AddClassOnValue(iValue As Int, sClass As String) As HTML5
	If iValue > 0 Then
		addClass(sClass)
	End If
	Return Me
End Sub

Sub AddClassOnCondition(bCondition As Boolean, sClass As String) As HTML5
	removeClass(sClass)
	If bCondition = True Then
		addClass(sClass)
	End If
	Return Me
End Sub

Sub AddClassOnFalseCondition(bCondition As Boolean, sClass As String) As HTML5
	removeClass(sClass)
	If bCondition = False Then
		addClass(sClass)
	End If
	Return Me
End Sub

Sub RemoveClassOnCondition(bCondition As Boolean, sClass As String) As HTML5
	If bCondition = True Then
		removeClass(sClass)
	End If
	Return Me
End Sub


Sub RemoveClassOnFalseCondition(bCondition As Boolean, sClass As String) As HTML5
	If bCondition = False Then
		removeClass(sClass)
	End If
	Return Me
End Sub


'add a list of elements
Sub AddContentList(lst As List) As HTML5
	For Each strContent As String In lst
		AddContent(strContent)
	Next
	Return Me
End Sub


'set the text of the element, in most cases you will use AddContent
Sub setText(sText As String,bAfter As Boolean) As HTML5
	Text = sText
	TextAfter = bAfter
	Return Me
End Sub

'set prefix
Sub setPrefix(sPrefix As String) As HTML5
	Prefix = sPrefix
	Return Me
End Sub

'set id
Sub setID(sID As String) As HTML5
	sID = sID.tolowercase
	ID = sID
	Return Me
End Sub

'set the tag, this updates the tab
Sub setTag(sTag As String) As HTML5
	Instance = sTag
	Return Me
End Sub

'set parent id
Sub setParentID(sParentID As String) As HTML5
	ParentID = sParentID
	Return Me
End Sub

'set read only
Sub setReadOnly(bReadOnly As Boolean) As HTML5
	ReadOnly = bReadOnly
	Return Me
End Sub

'set inline
Sub setInline(bInline As Boolean) As HTML5
	Inline = bInline
	Return Me
End Sub

'set enabled
Sub setEnabled(bEnabled As Boolean) As HTML5
	Enabled = bEnabled
	Return Me
End Sub

'set required
Sub setRequired(bRequired As Boolean) As HTML5
	Required = bRequired
	Return Me
End Sub

'Initializes the html builder
Public Sub Initialize(elID As String, eltag As String)
	ID = elID.ToLowerCase
	properties.Initialize
	properties.clear
	Contents.Initialize
	Contents.clear
	styles.Initialize
	styles.clear
	classes.Initialize
	classes.clear
	LooseAttributes.Initialize
	LooseAttributes.clear
	ParentID = ""
	DontBreak.Initialize
	DontBreak.clear
	DontBreak.Add("li")
	DontBreak.Add("a")
	DontBreak.Add("i")
	DontBreak.Add("span")
	DontBreak.Add("img")
	Instance = eltag
	Prefix = ""
	DoAProperClose = True
	Required = False
	Enabled = True
	Inline = False
	ReadOnly = False
	CSSRule.Initialize
	CSSRule.clear
	SingleQuote.Initialize
	SingleQuote.clear
	Text = ""
	TextAfter = False
End Sub

'remove a data attribute
public Sub removeAttrData(sData As String) As HTML5
	If sData.StartsWith("data-") Then
	Else
		sData = $"data-${sData}"$
	End If
	removeAttr(sData)
	Return Me
End Sub

'remove attribute
Sub removeAttribute(prop As String) As HTML5
	removeAttr(prop)
	Return Me
End Sub

'remove an attribute from the ones set
public Sub removeAttr(sName As String) As HTML5
	sName = sName.ToLowerCase
	sName = sName.Replace(" ",";")
	Dim sItems As List = StrParse(";",sName)
	For Each strStyle As String In sItems
		strStyle = strStyle.trim
		If properties.ContainsKey(strStyle) Then
			properties.Remove(strStyle)
		End If
	Next
	Return Me
End Sub

'remove an attribute from the ones set 
public Sub removeStyle(styleName As String) As HTML5
	styleName = styleName.Trim
	styleName = styleName.tolowercase
	styleName = styleName.Replace(" ",";")
	Dim sItems As List = StrParse(";",styleName)
	For Each strStyle As String In sItems
		strStyle = strStyle.trim
		If styles.ContainsKey(strStyle) Then
			styles.Remove(strStyle)
		End If
	Next
	Return Me
End Sub

'set a loose attribute
Sub setAttrLoose(value As String) As HTML5
	AddAttribute(value,value)
	Return Me
End Sub

'generate component builder code
private Sub GetComponentBuilder() As String
	Dim sb As StringBuilder
	sb.Initialize
	If Prefix.Length > 0 Then
		sb.Append(Prefix)
		sb.Append(CRLF)
	End If
	sb.Append("<")
	sb.Append(Instance)
	sb.Append(" ")
	If ID.Length > 0 Then
		sb.Append(ToProperty("id",ID))
	End If
	sb.Append(">")
	Select Case Instance.ToLowerCase
		Case "img", "link", "meta", "input", "source"
			DoAProperClose = False
	End Select
	If DoAProperClose = True Then
		sb.Append("</")
		sb.Append(Instance)
		sb.Append(">")
	End If
	sb.Append(CRLF)
	Dim sout As String = sb.tostring
	sout = sout.Trim
	Return sout
End Sub

'return a key value string for an attribute
private Sub ToProperty(sName As String, svalue As String) As String
	sName = CStr(sName)
	svalue = CStr(svalue)
	sName = sName.Replace("null","")
	sName = sName.Replace("undefined","")
	svalue = svalue.Replace("null","")
	svalue = svalue.Replace("undefined","")
	sName = sName.Trim
	svalue = svalue.trim
	If sName.Length > 0 Then
		Dim script As String = $"${sName}="${svalue}""$
		script = script.trim
		Return script
	Else
		Return ""
	End If
End Sub

private Sub CStr(o As Object) As String
	Return "" & o
End Sub


'add content to the element 
public Sub AddContent(value As String) As HTML5
	value = CStr(value)
	If value.Length > 0 Then
		value = FormatText(value)
		Contents.Add(value)
	End If
	Return Me
End Sub

'remove a class
public Sub removeClass(className As String) As HTML5
	className = className.Trim
	className = className.replace(" ",";")
	Dim sItems As List = StrParse(";",className)
	For Each strStyle As String In sItems
		strStyle = strStyle.Trim
		If classes.ContainsKey(strStyle) Then
			classes.Remove(strStyle)
		End If
	Next
	Return Me
End Sub

'add an element
public Sub AddElement(el As HTML5) As HTML5
	If el <> Null Then
		Dim scode As String = el.tostring
		AddContent(scode)
	End If
	Return Me
End Sub

'build the class attribute
private Sub BuildClass() As String
	Dim sb As StringBuilder
	sb.Initialize
	Dim kTot As Int = classes.Size - 1
	Dim kCnt As Int
	Dim strClass As String  = classes.GetKeyAt(0)
	sb.Append(strClass)
	For kCnt = 1 To kTot
		Dim strClass As String  = classes.GetKeyAt(kCnt)
		sb.Append(" ")
		sb.Append(strClass)
	Next
	Return sb.ToString
End Sub

'apply a style
Sub ApplyStyle(sStyle As String)
	'we expect a delimited string with ;
	sStyle = sStyle.Trim
	Dim pieces As List = StrParse(";",sStyle)
	For Each strPiece As String In pieces
		Dim attr As String = MvField(strPiece,1,":")
		Dim val As String = MvField(strPiece,2,":")
		attr = attr.Trim
		val = val.Trim
		If attr <> ""  Then
			AddStyleAttribute(attr,val)
		End If
	Next
End Sub

'build the styles
private Sub BuildStyle() As String
	Dim sb As StringBuilder
	sb.Initialize
	Dim kCnt As Int
	Dim kTot As Int = styles.Size - 1
	
	Dim strKey As String = styles.GetKeyAt(0)
	Dim strValue As String = styles.Get(strKey)
	Dim strLine As String = ToStyle(strKey,strValue)
	sb.Append(strLine)
	For kCnt = 1 To kTot
		Dim strKey As String = styles.GetKeyAt(kCnt)
		Dim strValue As String = styles.Get(strKey)
		Dim strLine As String = ToStyle(strKey,strValue)
		sb.Append(" ")
		sb.Append(strLine)
	Next
	Return sb.tostring
End Sub

'convert such to property
private Sub ToStyle(sName As String, sValue As String) As String
	sName = sName.Replace("undefined", "")
	sName = sName.Replace("null", "")
	sValue = sValue.Replace("undefined", "")
	sValue = sValue.Replace("null", "")
	sName = sName.Trim
	sValue = sValue.trim
	If sName.Length > 0 And sValue.Length > 0 Then
		If sName.EndsWith(":") Then
			sName = MvField(sName,1,":")
		End If
		Dim sout As String = $"${sName}:${sValue};"$
		If sout = ":;" Then sout = ""
		Return sout
	Else
		Return ""
	End If
End Sub

public Sub MvFieldFrom(sValue As String, iPosition As Int, Delimiter As String) As String
	If sValue.Length = 0 Then Return ""
	Dim mValues As List
	Dim tValues As Int
	If sValue.EndsWith(Delimiter) Then
		sValue = sValue & " "
	End If
	mValues = StrParse(Delimiter, sValue)
	tValues = mValues.size -1
	If tValues < iPosition Then
		Return mValues.get(tValues)
	End If
	Dim sb As StringBuilder
	sb.Initialize
	Dim startcnt As Int
	sb.Append(mValues.get(iPosition))
	For startcnt = iPosition + 1 To tValues
		sb.Append(Delimiter)
		sb.Append(mValues.get(startcnt))
	Next
	Return sb.tostring
End Sub

'define the opening of the element
private Sub Open() As String
	'update any loose attributes
	If Required = True Then setAttrLoose("required")
	If Enabled = False Then setAttrLoose("disabled")
	If Inline = True Then setAttrLoose("inline")
	If ReadOnly = True Then setAttrLoose("readonly")
	'build all classes for the element
	Dim thisClass As String = BuildClass
	thisClass = thisClass.trim
	If thisClass.Length > 0 Then
		AddAttribute("class", thisClass)
	End If
	'build the styles
	Dim thisStyle As String = BuildStyle
	thisStyle = thisStyle.trim
	If thisStyle.Length > 0 Then
		AddAttribute("style", thisStyle)
	End If
	Dim strValue As String
	Dim sb As StringBuilder
	sb.Initialize
	If Prefix.Length > 0 Then
		sb.Append(Prefix)
		sb.Append(CRLF)
	End If
	sb.Append("<")
	sb.Append(Instance)
	sb.Append(" ")
	If ID.Length > 0 Then
		sb.Append(ToProperty("id",ID))
		sb.Append(" ")
	End If
	'
	Dim kTot As Int = properties.Size - 1
	Dim kCnt As Int
	Dim strKey As String = properties.GetKeyAt(0)
	strValue = properties.Get(strKey)
	If SingleQuote.IndexOf(strKey) = -1 Then
		sb.Append(ToProperty(strKey,strValue))
	Else
		sb.Append(ToSingleQuoteProperty(strKey,strValue))
	End If
	For kCnt = 1 To kTot
		Dim strKey As String = properties.GetKeyAt(kCnt)
		strValue = properties.Get(strKey)
		sb.Append(" ")
		If SingleQuote.IndexOf(strKey) = -1 Then
			sb.Append(ToProperty(strKey,strValue))
		Else
			sb.Append(ToSingleQuoteProperty(strKey,strValue))
		End If
	Next
	sb.Append(">")
	sb.Append(CRLF)
	Return sb.tostring
End Sub

'single quote property
private Sub ToSingleQuoteProperty(sName As String, svalue As String) As String
	Dim script As String = $"${sName}='${svalue}'"$
	script = script.Trim
	If script = "=''" Then
		script = ""
	End If
	Return script
End Sub

'format the text
private Sub FormatText(sText As String) As String
	Dim RM As Map
	RM.Initialize
	RM.clear
	RM.Put("{U}", "<ins>")
	RM.Put("{/U}", "</ins>")
	RM.Put("¢","&cent;")
	RM.put("£","&pound;")
	RM.Put("{SUP}", "<sup>")
	RM.Put("{/SUP}", "</sup>")
	RM.Put("¥","&yen;")
	RM.Put("€","&euro;")
	RM.put("©","&copy;")
	RM.Put("®","&reg;")
	RM.Put("{POUND}","&pound;")
	RM.Put("{/B}", "</b>")
	RM.Put("{I}", "<i>")
	RM.Put("{YEN}","&yen;")
	RM.Put("{EURO}","&euro;")
	RM.Put("{CODE}","<code>")
	RM.Put("{/CODE}","</code>")
	RM.put("{COPYRIGHT}","&copy;")
	RM.Put("{REGISTERED}","&reg;")
	RM.Put("®", "&reg;")
	RM.Put("{B}", "<b>")
	RM.Put("{SMALL}", "<small>")
	RM.Put("{/SMALL}", "</small>")
	RM.Put("{EM}", "<em>")
	RM.Put("{/EM}", "</em>")
	RM.Put("{MARK}", "<mark>")
	RM.Put("{/MARK}", "</mark>")
	RM.Put("{/I}", "</i>")
	RM.Put("{SUB}", "<sub>")
	RM.Put("{/SUB}", "</sub>")
	RM.Put("{BR}", "<br/>")
	RM.Put("{WBR}","<wbr>")
	RM.Put("{STRONG}", "<strong>")
	RM.Put("{/STRONG}", "</strong>")
	RM.Put("{NBSP}", "&nbsp;")
	RM.Put("“","")
	RM.Put("”","")
	RM.Put("’","'")
	Dim kTot As Int = RM.Size - 1
	Dim kCnt As Int
	For kCnt = 0 To kTot
		Dim strValue As String = RM.GetKeyAt(kCnt)
		Dim strRep As String = RM.Get(strValue)
		sText = sText.Replace(strValue, strRep)
	Next
	Return sText
End Sub

'remove the delimiter
private Sub RemDelim(sValue As String, Delim As String) As String
	If sValue.EndsWith(Delim) Then
		Dim lDelim As Int = Delim.Length
		Dim nValue As String = sValue
		If nValue.EndsWith(Delim) Then
			nValue = nValue.SubString2(0, nValue.Length-lDelim)
		End If
		Return nValue
	Else
		Return sValue
	End If
End Sub

'set a style property
Sub AddStyleAttribute(sprop As String, svalue As String) As HTML5
	sprop = sprop.ToLowerCase
	sprop = sprop.Trim
	svalue = svalue.Trim
	'remove any colon
	sprop = RemDelim(sprop,":")
	'remove any semicolon
	svalue = RemDelim(svalue,";")
	sprop = sprop.Trim
	svalue = svalue.Trim
	If svalue.Length > 0 And sprop.Length > 0 Then
		'important has already been provided, dont include it
		If svalue.EndsWith("!important") = False Then
			svalue = svalue & " !important"
		End If
		'update the style map
		styles.Put(sprop, svalue)
	End If
	Return Me
End Sub

'mvfield sub
private Sub MvField(sValue As String, iPosition As Int, Delimiter As String) As String
	If sValue.Length = 0 Then Return ""
	Dim xPos As Int = sValue.IndexOf(Delimiter)
	If xPos = -1 Then Return sValue
	Dim mValues As List = StrParse(Delimiter,sValue)
	Dim tValues As Int
	tValues = mValues.size -1
	Select Case iPosition
		Case -1
			Return mValues.get(tValues)
		Case -2
			Return mValues.get(tValues - 1)
		Case -3
			Dim sb As StringBuilder
			sb.Initialize
			Dim startcnt As Int
			sb.Append(mValues.Get(1))
			For startcnt = 2 To tValues
				sb.Append(Delimiter)
				sb.Append(mValues.get(startcnt))
			Next
			Return sb.tostring
		Case Else
			iPosition = iPosition - 1
			If iPosition <= -1 Then
				Return mValues.get(tValues)
			End If
			If iPosition > tValues Then
				Return ""
			End If
			Return mValues.get(iPosition)
	End Select
End Sub

'add a class to the element
Sub addClass(value As String) As HTML5
	'add classes delimited by space
	value = value.Replace(" ",";")
	Dim spClasses As List = StrParse(";",value)
	For Each strClass As String In spClasses
		strClass = strClass.Trim
		If strClass.Length > 0 Then
			classes.Put(strClass,strClass)
		End If
	Next
	Return Me
End Sub

'set attribute
public Sub AddAttribute(skey As String, svalue As String) As HTML5
	properties.Put(skey,svalue)
	Return Me
End Sub


' parse a string to a list
private Sub StrParse(Delim As String, InputString As String) As List
	Dim OutList As List
	Dim CommaLoc As Int
	OutList.Initialize
	OutList.clear
	CommaLoc=InputString.IndexOf(Delim)
	Do While CommaLoc >-1
		Dim LeftSide As String
		LeftSide= InputString.SubString2(0,CommaLoc)
		Dim RightSide As String
		RightSide= InputString.SubString(CommaLoc+1)
		OutList.Add(LeftSide)
		InputString=RightSide
		CommaLoc=InputString.IndexOf(Delim)
	Loop
	OutList.Add(InputString)
	Return OutList
End Sub

'join list to a string
private Sub Join(delimiter As String, lst As List) As String
	Dim i As Int
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(lst.get(0))
	For i = 1 To lst.size - 1
		sb.Append(delimiter).Append(lst.get(i))
	Next
	Return sb.ToString
End Sub

'define the closure of the element
private Sub Close() As String
	Dim sb As StringBuilder
	sb.Initialize
	Select Case Instance.ToLowerCase
		Case "img", "link", "meta", "input", "source", "hr", "br"
			DoAProperClose = False
	End Select
	If DoAProperClose = True Then
		sb.Append("</")
		sb.Append(Instance)
		sb.Append(">")
	End If
	sb.Append(CRLF)
	Return sb.tostring
End Sub

'get the attribute
Sub getAttr(attr As String) As String
	attr = attr.tolowercase
	If properties.ContainsKey(attr) Then
		Return properties.Get(attr)
	Else
		Return ""
	End If
End Sub


'turn the element into html
public Sub ToString As String
	If ParentID <> "" Then
		ID = ParentID & ID
	End If
	Select Case Instance
		Case "img", "script"
			'to later check for broken links
			Dim imgURL As String = getAttr("src")
			If imgURL.Length > 0 Then
				imgURL = imgURL.tolowercase
			End If
		Case "link"
			Dim lnk As String = getAttr("href")
			If lnk.Length > 0 Then
				lnk = lnk.tolowercase
			End If
	End Select
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append(Open)
	If TextAfter = True Then
		Contents.Add(Text)
	Else
		Contents.InsertAt(0,Text)
	End If
	For Each strContent As String In Contents
		If strContent.Length > 0 Then
			sb.Append(strContent)
		End If
	Next
	sb.Append(Close)
	Dim sout As String = sb.ToString
	If DontBreak.IndexOf(Instance) <> -1 Then
		sout = sout.Replace(CRLF,"")
	End If
	'add any code To the page
	sout = sout.Replace(CRLF,"")
	Return sout
End Sub
