﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
#IgnoreWarnings: 12
Sub Class_Globals
	Public ID As String
	Public Theme As String
	Public Element As HTML5
	Public Inset As Boolean
	Public Visible As Boolean
	Public AddBackButton As Boolean
	Public Fixed As Boolean
	Public Inline As Boolean
	Public FullScreen As Boolean
	Public Page As JQMPage
End Sub

Sub AddClass(sclass As String)
	Element.addClass(sclass)
End Sub

Sub AddStyle(prop As String, value As String)
	Element.AddStyleAttribute(prop,value)
End Sub

Sub AddAttribute(prop As String, value As String)
	Element.AddAttribute(prop,value)
End Sub

Sub AddContainer(thisCont As JQMContainer)
	AddComponent(thisCont.tostring)
End Sub

Sub AddContentList(lst As List)
	Element.AddContentList(lst)
End Sub

Sub AddLink(sid As String, lnkText As String, lnkSecondary As String, lnkURL As String, lnkTransition As String, lnkIcon As String)
	Dim a As HTML5
	a.Initialize(sid,"a")
	a.sethref(lnkURL)
	a.AddContent(lnkText)
	If lnkSecondary.Length > 0 Then
		Dim span As HTML5
		span.Initialize($"${sid}span"$,"span")
		span.addclass("ui-li-count")
		span.AddContent(lnkSecondary)
		a.AddContent(span.ToString)
	End If
	a.setAttrData("transition", lnkTransition)
	a.setAttrData("icon", lnkIcon) 
	AddComponent(a.ToString)
	Page.AddEvent(sid, "click")
End Sub

Sub SetHREF(href As String)
	Element.sethref(href)
End Sub

Sub SetTag(Tag As String)
	Element.Tag = Tag
End Sub

Sub SetAttrData(attr As String, value As String)
	Element.setAttrData(attr,value)
End Sub

Sub AddLeftButton(bid As String,bText As String, bURL As String, bIcon As String, bIconPos As String, bTransition As String, bReverse As Boolean, bTheme As String)
	Dim btn As JQMButton
	btn.Initialize(Page,bid)
	btn.Theme = bTheme
	btn.Text = bText
	btn.HREF = bURL
	btn.Icon = bIcon
	btn.IconPos = bIconPos
	btn.Position = "ui-btn-left"
	btn.Transition = bTransition
	btn.Reverse = bReverse
	AddButton(btn)
End Sub


Sub AddButton1(bid As String,bText As String, bURL As String, bIcon As String, bIconPos As String, bTransition As String, bTheme As String)
	Dim btn As JQMButton
	btn.Initialize(Page,bid)
	btn.Theme = bTheme
	btn.Text = bText
	btn.HREF = bURL
	btn.Icon = bIcon
	btn.IconPos = bIconPos
	btn.Transition = bTransition
	AddButton(btn)
End Sub

Sub AddRightButton(bid As String,bText As String, bURL As String, bIcon As String, bIconPos As String, bTransition As String, bReverse As Boolean, bTheme As String)
	Dim btn As JQMButton
	btn.Initialize(Page,bid)
	btn.Theme = bTheme
	btn.Text = bText
	btn.HREF = bURL
	btn.Icon = bIcon
	btn.IconPos = bIconPos
	btn.Position = "ui-btn-right"
	btn.Transition = bTransition
	btn.Reverse = bReverse
	AddButton(btn)
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(pg As JQMPage, sID As String)
	Page = pg
	ID = sID.tolowercase
	Element.Initialize(ID,"div") 
	Inset = False
	Visible = True
	AddBackButton = False
	Fixed = False
	Inline = False
	FullScreen = False
End Sub

Sub AddComponent(comp As String)
	Element.AddContent(comp)
End Sub

Sub AddBreak
	Dim script As String = "{BR}"
	Element.AddContent(script)
End Sub

Sub SetText(txt As String)
	Element.SetContents(txt)
End Sub

Sub AddButton(btn As JQMButton)
	Element.AddContent(btn.ToString)
	Page.AddEvent(btn.ID, "click")
End Sub

Sub AddH1(sid As String, sContent As String)
	sid = sid.tolowercase
	Dim h1 As HTML5
	h1.Initialize(sid,"h1")
	h1.AddContent(sContent)
	Element.AddContent(h1.ToString) 
End Sub

Sub AddH2(sid As String, sContent As String)
	sid = sid.tolowercase
	Dim h1 As HTML5
	h1.Initialize(sid,"h2")
	h1.AddContent(sContent)
	Element.AddContent(h1.ToString) 
End Sub

Sub AddH4(sid As String, sContent As String)
	sid = sid.tolowercase
	Dim h1 As HTML5
	h1.Initialize(sid,"h4")
	h1.AddContent(sContent)
	Element.AddContent(h1.ToString) 
End Sub

Sub AddH5(sid As String, sContent As String)
	sid = sid.tolowercase
	Dim h1 As HTML5
	h1.Initialize(sid,"h5")
	h1.AddContent(sContent)
	Element.AddContent(h1.ToString) 
End Sub

Sub AddH6(sid As String, sContent As String)
	sid = sid.tolowercase
	Dim h1 As HTML5
	h1.Initialize(sid,"h6")
	h1.AddContent(sContent)
	Element.AddContent(h1.ToString) 
End Sub

Sub AddH3(sid As String, sContent As String)
	sid = sid.tolowercase
	Dim h1 As HTML5
	h1.Initialize(sid,"h3")
	h1.AddContent(sContent)
	Element.AddContent(h1.ToString) 
End Sub

Sub AddElement(el As HTML5)
	AddComponent(el.ToString)
End Sub

Sub AddParagraph(sid As String, sContent As String)
	sid = sid.tolowercase
	Dim h1 As HTML5
	h1.Initialize(sid,"p")
	h1.AddContent(sContent)
	Element.AddContent(h1.ToString) 
End Sub

Sub setTheme(sTheme As String)
	Element.setAttrData("theme", sTheme)
End Sub

'return the container content
Sub ToString As String
	If Inline Then
		Element.setAttrData("inline", "true")
	End If
	If FullScreen Then
		Element.setAttrData("fullscreen", "true")
	End If
	If Fixed Then
		Element.setAttrData("position", "fixed")
	End If
	If AddBackButton Then
		Element.setAttrData("add-back-btn", "true")
	End If
	If Inset Then
		Element.setAttrData("inset", "true")
	End If
	Element.setAttrData("theme", Theme)
	If Visible = False Then Return ""
	Return Element.tostring
End Sub