﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7
@EndOfDesignText@
Sub Class_Globals
	Public BANano As BANano
	Public ID As String
	Public Header As JQMContainer
	Public Content As JQMContainer
	Public Footer As JQMContainer
	Private Page As JQMContainer
	Public Title As String
	Public Cache As Boolean
	Public DataURL As String
	Public FullScreen As Boolean
	Public Theme As String
	Public Events As Map
	Public App As JQMApp
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(thisApp As JQMApp, sID As String)
	App = thisApp
	Events.Initialize
	Events.clear
	ID = sID.ToLowerCase
	'define the header
	Header.Initialize(Me,$"${ID}hdr"$)
	Header.SetAttrData("role", "header")
	
	'define the page content
	Content.Initialize(Me,$"${ID}cnt"$)
	Content.SetattrData("role", "main")
	Content.addClass("ui-content")
	'define the footer
	Footer.Initialize(Me,$"${ID}ftr"$)
	Footer.setAttrData("role", "footer")
	
	'define the page
	Page.Initialize(Me,ID)
	Page.element.setdatarole("page")
	Cache = False
	DataURL = ""
	FullScreen = False
	Theme = ""
End Sub

Sub ToString As String
	If Theme.Length > 0 Then
		Page.Element.setAttrData("theme", Theme)
	End If
	If FullScreen Then
		Page.Element.setAttrData("fullscreen", True)
	End If
	If Cache Then
		Page.Element.setAttrData("dom-cache", "true")
	End If
	If Title.Length > 0 Then
		Page.Element.setAttrData("data-title", Title)
	End If
	If DataURL.Length > 0 Then
		Page.Element.setAttrData("url", DataURL)
	End If
	'update the page theme
	'add all components to the page
	Page.Element.AddContent(Header.ToString)
	'add the content
	Page.Element.AddContent(Content.ToString)
	Page.Element.AddContent(Footer.ToString)
	Return Page.ToString
End Sub

'banano append call
Sub Append(elID As String, elContent As String)
	elID = elID.tolowercase
	BANano.GetElement($"#${elID}"$).Append(elContent)
End Sub

'add events to the page (this should be done once the elements are added to the page
Sub BindEvents(EventName As String, EventHandler As Object)
	'loop through each event and add handlers to it
	Dim kTot As Int = Events.Size - 1
	Dim kCnt As Int
	For kCnt = 0 To kTot
		Dim strbtn As String = Events.GetKeyAt(kCnt)
		Dim sEvent As String = Events.get(strbtn)
		Dim sKey As String = $"#${strbtn}"$
		'ids and events are lowercase
		sKey = sKey.tolowercase
		sEvent = $"${strbtn}_${sEvent}"$
		If EventName.Length > 0 Then sEvent = EventName
		sEvent = sEvent.tolowercase
		If EventHandler <> Null Then
			Dim elm As BANanoElement = BANano.GetElement(sKey)
			elm.Off(sEvent)
			elm.HandleEvents(sEvent, EventHandler, sEvent)
		End If
	Next
End Sub

'add an event for a control
Sub AddEvent(btnID As String, elEvent As String)
	btnID = btnID.tolowercase
	btnID = btnID.Trim
	If btnID.Length > 0 Then
		Events.Put(btnID,elEvent)
	End If
End Sub
